=== debian/changelog ===
openvas-scanner (5.1.3-2) unstable; urgency=medium

  * Team upload.
  * Bump minimal version of libopenvas-dev to 9.0.3

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 31 Aug 2018 15:00:08 +0200

openvas-scanner (5.1.3-1) unstable; urgency=medium

  * Import new upstream release
  * Add upstream metadata
  * d/control:
    - Bump Standards-Version to 4.2.1
  * d/copyright:
    - Replace "http" with "https" in URL
  * d/changelog:
    - Remove trailing whitespace

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 31 Aug 2018 17:29:16 +0800
