=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DLOCALSTATEDIR=/var -DSYSCONFDIR=/etc -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=release

override_dh_missing:
	dh_missing --fail-missing
